SystemOrganization addCategory: #BackgammonController!

Object subclass: #BackgammonStart
	instanceVariableNames: 'myBoardModel myBoardView observables diceView1 diceView2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonController'!

!BackgammonStart commentStamp: 'DavidOvergaard 7/16/2015 21:27' prior: 0!
Initialize and run backgammon game!

!BackgammonStart class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:27'!
start
	^BackgammonStart new start.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 14:17'!
displayBoardDice
	| boardHeight boardWidth |
	boardHeight := myBoardView getBoardSize y.	"Add the dice to the board"
	boardWidth := myBoardView getBoardSize x.
	diceView1 := DieView dieModel: myBoardModel dice1.
	myBoardView addMorph: (diceView1 dieMorph
		left: boardWidth / 2 - 50 - 50;
		top: boardHeight / 2 - 15).
	diceView2 := DieView dieModel: myBoardModel dice2.
	myBoardView addMorph: (diceView2 dieMorph
		left: boardWidth / 2 + 50 - 50;
		top: boardHeight / 2 - 15)! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:01'!
model
	^myBoardModel.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:23'!
observable: anObject
	observables add: anObject.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:16'!
observables
	^observables! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 13:59'!
promptForPlayersNames
	"Ask each player in turn about their name and update the model"
	"Prompt for player 1"
	| player1Name player2Name |
	player1Name := UIManager default request: 'Player 1 name:' initialAnswer: 'Ahmed'.
	myBoardModel player1 nameOfPlayer: player1Name.
	
	"Prompt for player 2"
	player2Name := UIManager default request: 'Player 2 name:' initialAnswer: 'Bob'.
	myBoardModel player2 nameOfPlayer: player2Name.
	
	"myBoardView displayNameForPlayer1: player1Name  Player2: player2Name"  ! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/26/2015 18:24'!
start
	| diceButton |

	myBoardModel := MainBoard newGame.
	

	
	myBoardView := BackgammonBoard createNewBoard: self.
"	observables := OrderedCollection new."
	myBoardModel player1Checkers
		do: [ :aChecker | 
			myBoardView addCheckerAtPoint: aChecker checkerLocation pointNumber color: aChecker color.
			aChecker addObserver: myBoardView lastAddedChecker ].
	myBoardModel player2Checkers
		do: [ :aChecker | 
			myBoardView addCheckerAtPoint: aChecker checkerLocation pointNumber color: aChecker color.
			aChecker addObserver: myBoardView lastAddedChecker ].	"Test move with observer"

	self displayBoardDice.	
	
	diceButton := InputButton text: 'Roll dice' boardHeight: myBoardView getBoardSize y.
	"diceButton mouseAction: [ diceButton rollDie: myBoardModel. ]."
	myBoardView addMorph: diceButton.	"self promptForPlayersNames ."	"Add the dice to the board"

	"self promptForPlayersNames .	"
	
	myBoardView drawBearOffChecker1With: (myBoardModel player1BOChecker).
	myBoardView drawBearOffChecker2With: (myBoardModel player2BOChecker).
	myBoardModel offLocationP1 addObserver: (myBoardModel player1BOChecker).
	myBoardModel offLocationP2 addObserver: (myBoardModel player2BOChecker).! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 00:39'!
updatedBearOffCheckerCount
	self model offLocationP1 incrementNumCheckersOnHome! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:40'!
updatedBearOffCheckerCountByColor:aColor
	(aColor = (self model player1 checkerColor))
			ifTrue: [ 
				self model offLocationP1 incrementNumCheckersOnHome
			 ]
			ifFalse: [ 
				self model offLocationP2 incrementNumCheckersOnHome
			 ].
	
	! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/24/2015 20:06'!
updatedChecker: aChecker toHome: pointNum
	| modelChecker moveCheckerCommand |
"	Transcript show: (aChecker location)."
	modelChecker := aChecker observable.
	
	(pointNum = 25)
	ifTrue: [ 
		 	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: (myBoardModel player1Off).
		 ]
	ifFalse: [ 
		(pointNum = 26)
		ifTrue: [
				 	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: (myBoardModel player2Off).
			].
		].
	moveCheckerCommand execute.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:43'!
updatedChecker: aChecker toPointNum: pointNum
	| modelChecker moveCheckerCommand |
"	Transcript show: (aChecker location)."
	modelChecker := aChecker observable.
	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: (myBoardModel points at: pointNum).
	
	moveCheckerCommand execute.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:02'!
view
	^myBoardView := BackgammonBoard createNewBoard.! !
